type 'a graph = 'a list * 'a edge list
and 'a edge = 'a * weight * 'a
and weight = int;;

(* Voici la signature du module Unionfind
 * type elem
 * val make: unit -> elem
 * val find: elem -> elem
 * val eq: elem -> elem -> bool
 * val union: elem -> elem -> unit *)

let kruskal (g : 'a graph) : 'a edge list =
  (*  implmenter *)
  [];;

(* Exemple du cours, kruskal exemple doit renvoyer
 * [(4,8,5);(0,5,4);(0,4,1);(2,2,3);(1,1,3)] *)
let exemple : int graph =
  ([0;1;2;3;4;5],
   [
     (0,4,1);
     (0,6,2);
     (0,5,4);
     (1,3,2);
     (1,1,3);
     (1,9,5);
     (2,2,3);
     (2,10,5);
     (4,8,5);
  ]);;

Graphics.open_graph "";;

let points: (int*int) list ref = ref [];;
let edges: (int*int) edge list ref = ref [];;

let draw_point (x,y) = Graphics.fill_circle x y 5;;
let draw_edge ((x1,y1),_,(x2,y2)) =
  Graphics.moveto x1 y1; Graphics.lineto x2 y2;;


let click (status : Graphics.status) =
  let (x,y) = (status.mouse_x, status.mouse_y) in
  Graphics.clear_graph ();
  (* Ajouter les nouvelles artes *)
  points := (x,y) :: !points;
  List.iter draw_point !points;
(* Trouver l'arbre couvrant et l'afficher *)
;;

Graphics.loop_at_exit [Graphics.Button_down] click;;
